﻿
window.addEventListener("load", windowLoadHandler, false);
var startEvent = 'touchstart';
var moveEvent = 'touchmove';
var endEvent = 'touchend';
function windowLoadHandler() {
    document.addEventListener("deviceready", onDeviceReady, false);
    var isTouchSupported = 'ontouchstart' in window;
    startEvent = isTouchSupported ? 'touchstart' : 'mousedown';
    moveEvent = isTouchSupported ? 'touchmove' : 'mousemove';
    endEvent = isTouchSupported ? 'touchend' : 'mouseup';
     
}
var canvasWidth = window.innerWidth;
var canvasheight = window.innerHeight;
var groudHeight = 85;
var isGameLost = false;
var isGameOver = false;
//c.width = window.innerWidth;
//c.height = window.innerHeight;

//var c = document.getElementById("gameCanvas");
var canvas = $("#gameCanvas")[0].getContext('2d');


$("#gameCanvas").attr('width', canvasWidth);
$("#gameCanvas").attr('height', canvasheight);

$("#gameCanvas")[0].addEventListener(startEvent, mouseDownListener, false);



var image_cat = new Image();
image_cat.src = "CAT_01.png";
image_cat.height = 75;
image_cat.width = 75;

var image_mouse = new Image();
image_mouse.src = "Rat.png";
image_mouse.height = 10;
image_mouse.width = 10;



var image_Right = new Image();
image_Right.src = "right.png";
image_Right.height = 10;
image_Right.width = 10;



var image_Left = new Image();
image_Left.src = "left.png";
//image_Left.height = 15;
//image_Left.width = 15;


var image_Jump = new Image();
image_Jump.src = "jump.png";
image_Jump.height = 10;
image_Jump.width = 10;


var imgNext = new Image();
imgNext.src = "next.png";
imgNext.height = 10;
imgNext.width = 10;

var imgPlay = new Image();
imgPlay.src = "play.png";
imgPlay.height = 10;
imgPlay.width = 10;
var points = [];
var totalpoints = 0;


var arryRatImage = [];
var gapincanvas = canvasWidth / 10;
for (var i = 0; i < 10; i++) {
   

    arryRatImage.push({id:'rat_'+i.toString(),type:'rat',point:10,
        image: image_mouse, x: Math.random() *(canvasWidth - image_mouse.width), y: image_mouse.height / 2 + Math.random() * 100, inscreen: false
        , speed: 3 
    });
}

//clamp(catX, 0, canvasWidth-image_cat.width);
 //alert(JSON.stringify(arryRatImage));

var arryfireImage = [];

var image_fish = new Image();
image_fish.src = "Fish.png";

for (var i = 0; i < 5; i++) {
  
   // arryRatImage.push({ id: 'fish_' + i.toString(), type: 'fish', point: 5, image: image_fish, x: Math.random() * (canvasWidth - image_fish.width), y: image_fish.height / 2 + Math.random() * 25, inscreen: false, speed: 3 });
}


 
var image_fire = new Image();
image_fire.src = "fire.png";

for (var i = 0; i < 10; i++) {

    arryRatImage.push({ id: 'fire_' + i.toString(), type: 'fire', point: -50, image: image_fire, x: Math.random() * (canvasWidth - image_fire.width), y: image_fire.height / 2 + Math.random() * 25, inscreen: false, speed: Math.random() * 10 });
}



var catX = (canvasWidth / 2) - image_cat.width / 2;
var catY = (canvasheight-groudHeight);// - image_cat.height / 2;


//var mouseX = (canvasWidth / 2) - image_mouse.width / 2;
//var mouseY = image_mouse.height / 2;

 

var FPS = 30;
var flip = false;
var deg = 1;
var isjump = false;
gameloop();
var iloop = 0;


function gameloop()
{
    // console.log('draw');
    getselectitems();

    update();
    draw();
    if (isjump)
    {
        if (iloop > 10) {
            catY = (canvasheight) - image_cat.height / 2;
            catX = catX + 5;
            isjump = false;
            iloop = 0;
        }
        else {
            iloop++;
        }
       
       // isjump = false;
        //   draw();
       

    }
    setTimeout(gameloop
   , 1000 / FPS);
    
   
}

function update()
{
    catX = clamp(catX, 0, canvasWidth-image_cat.width);
    catY = clamp(catY, 0, canvasheight - image_cat.height);

    for (var k in arryRatImage) {
         arryRatImage[k].x = clamp(arryRatImage[k].x, 0, canvasWidth - arryRatImage[k].image.width);
       // arryRatImage[k].y = clamp(arryRatImage[k].y, 0, canvasheight - arryRatImage[k].image.height);
         if (HitImages(arryRatImage[k])) {
            // arryRatImage[k].x = 0;
            arryRatImage[k].inscreen = false;
            arryRatImage[k].y = -25;
             //alert(arryRatImage[k].y);


        }
         else
        {
             if (arryRatImage[k].y > (canvasheight - arryRatImage[k].image.height - groudHeight))
            {
                //alert(arryRatImage[k].y);
                arryRatImage[k].y = -25;
                arryRatImage[k].inscreen = false;

            }
        }
         
    }
    //update ponints
  
    if (points.length > 0) {
        for (var i in points) {
            if (points[i].y < 0) {
                points.splice(i, 1);
            }
            else {
                points[i].y = points[i].y - 3;
            }
        }
    }
    
    
}

$("#btnright").click(function ()
{
    catX = catX + 10;
   // catY = catY - 10;
    if (flip) {
        flip = false;
    }
});
$("#btnjump").click(function () {
   
    // catY = catY - 10;
    if (flip) {
        catX = catX - 10;
        
    }
    else
    {
        catX = catX + 10;
    }
    catY = catY - 50;
    isjump = true;
});

$("#btnleft").click(function ()
{
    catX = catX - 10;
  //  catY = catY - 10;

    if(!flip)
    {
        flip = true;
    }
});

function clamp(x,min,max)
{
    return x < min ? min : (x > max ? max : x);
}
function draw()
{

   
    
    canvas.clearRect(0, 0, canvasWidth, canvasheight);
    canvas.strokeRect(0, 0, canvasWidth, canvasheight);
    canvas.save();
    var xyz = canvasWidth / 4;
    canvas.drawImage(image_Left, xyz-5, canvasheight - 40, 40, 40);// catX, catY);
    canvas.drawImage(image_Jump, xyz + 40, canvasheight - 40, 40, 40);// catX, catY);
    canvas.drawImage(image_Right, xyz + 85, canvasheight - 40, 40, 40);// catX, catY);
    Message(totalpoints);

    if (isGameLost)
    {
        
        MessageGameOver(1);
        
        return;
    }
    else if (isGameOver)
    {
        MessageGameOver(2);
        return;
    }
    

    canvas.translate(catX + image_cat.width / 2, catY + image_cat.height / 2);

    // Rotate the canvas around the origin
    var rad;
    if (flip) {
        var rad = deg * Math.PI / 180;
    } else {
          rad = 2 * Math.PI - deg * Math.PI / 180;
    }
   
    canvas.rotate(rad);
    if (flip) {
        canvas.scale(-1, 1);
    }
    // canvas.translate(catX, catY);
   
    // canvas.rotate((Math.PI / 180) * 200);
  
    canvas.drawImage(image_cat, -(image_cat.width / 2), -groudHeight, image_cat.width, image_cat.height);// catX, catY);
   
    
    canvas.restore();
    for (var k in arryRatImage) {

        if (arryRatImage[k].inscreen) {
            //alert(arryRatImage[k].inscreen);

            checkImagesTouchEachOther(arryRatImage[k]);
            
                canvas.drawImage(arryRatImage[k].image, arryRatImage[k].x, arryRatImage[k].y);
               
           
            arryRatImage[k].y += arryRatImage[k].speed; //Set the falling speed
           
        }
    }

    if (points.length > 0) {
        //alert(JSON.stringify(points));

        for (var i in points) {
             
            DrawPoints(points[i].x, points[i].y, points[i].point);
        }
    }
}


function HitImages(obj) {

    
    var flag = false;
    var mx=obj.x, my=obj.y;
    var left = catX, right = catX + image_cat.width;
    var top = catY-groudHeight, bottom = catY + image_cat.height;

    if (right >= mx
        && left <= mx
        && bottom >= my
        && top <= my) {
       
       // console.info('point'+obj.point)
        points.push({ x: mx, y: my, point: parseInt(obj.point) });
        
     
        if (parseInt(obj.point)>0)
        {
            PlayEat();
        }
        totalpoints = totalpoints + parseInt(obj.point);

        //$("#point").html(totalpoints);
      //  Message(totalpoints);
        if (totalpoints < 0)
        {
            isGameLost = true;
          // alert('try again');
        }
        else if (totalpoints > 999)
        {
            isGameOver = true;
        }
        flag = true;

        eatCount++;
        fallobjectCount = Math.random() * 5;
        if(fallobjectCount<=1)
        {
            fallobjectCount = 3;
        }

    }


    return flag;

}


function DrawPoints(x,y,point)
{
     
    canvas.beginPath();
     
    canvas.fillStyle = "black"
    canvas.font = "12px Georgia";
    canvas.fillText(point, x, y);

    canvas.closePath();
}


function getselectitems()
{

   // var selcteditems = [];

    arryRatImage = shuffle(arryRatImage);
     
    var k = 1;
    var m = 1;

    for (var j = 0; j < arryRatImage.length; j++) {
        if (arryRatImage[j].inscreen) {
            m = m + 1;
        }
    }
    console.info('m' + m);
    console.info(fallobjectCount);
    
    if (m <= fallobjectCount) {
      //  console.info(fallobjectCount);
        for (var i = 0; i < arryRatImage.length; i++) {
            if (!arryRatImage[i].inscreen) {
                 
                if (!checkbothImagesTouch(arryRatImage[i])) {
                    console.info('k' + k);
                    if (k < fallobjectCount) {
                       
                        arryRatImage[i].inscreen = true;
                        k++;
                    }
                }
            }
        }
    }

   // return selcteditems;
}


function checkbothImagesTouch(obj)
{
    var flag = false;
    for (var j = 0; j < arryRatImage.length; j++) {
        if (arryRatImage[j].inscreen) {
           
            obj.x = clamp(obj.x, 0, canvasWidth - obj.image.width);
            obj.y = clamp(obj.y, 0, canvasheight - obj.image.height);
            var left1 = arryRatImage[j].x, right1 = arryRatImage[j].x + arryRatImage[j].image.width;
            var top1 = arryRatImage[j].y, bottom1 = arryRatImage[j].y + arryRatImage[j].image.height;
            var left = obj.x, right = obj.x + obj.image.width;
            var top = obj.y, bottom = obj.y + obj.image.height;

            if (right >= arryRatImage[j].x
                && left <= arryRatImage[j].x
                && bottom >= arryRatImage[j].y
                && top <= arryRatImage[j].y) {
                obj.y += obj.speed + obj.image.height;
                flag = true;
                break;
            }
            else if (right1 >= obj.x
                && left1 <= obj.x
                && bottom1 >= obj.y
                && top1 <= obj.y) {
                flag = true;
                obj.y += obj.speed+20;
                //   arryRatImage[j].inscreen = false;
                // alert(flag);
                    break;
            }

        }
    }

    return flag;
}




function checkImagesTouchEachOther(obj) {
    var flag = false;
    for (var j = 0; j < arryRatImage.length; j++) {
        if (arryRatImage[j].inscreen && arryRatImage[j].id != obj.id) {
 
           var left1 = arryRatImage[j].x, right1 = arryRatImage[j].x + arryRatImage[j].image.width;
              var top1 = arryRatImage[j].y, bottom1= arryRatImage[j].y + arryRatImage[j].image.height;
            var left = obj.x, right = obj.x + obj.image.width;
            var top = obj.y, bottom = obj.y + obj.image.height;

            if (right >= arryRatImage[j].x
                && left <= arryRatImage[j].x
                && bottom >= arryRatImage[j].y
                && top <= arryRatImage[j].y) {
                flag = true;
                arryRatImage[j].y += arryRatImage[j].speed+2;
             //   arryRatImage[j].inscreen = false;
               // alert(flag);
             //   break;
            }
           else if (right1 >= obj.x
                && left1 <= obj.x
                && bottom1 >= obj.y
                && top1 <= obj.y) {
                flag = true;
                obj.y += obj.speed;
                //   arryRatImage[j].inscreen = false;
                // alert(flag);
                //   break;
            }
        }
    }

    return flag;
}



function shuffle(o) { //v1.0
    for (var j, x, i = o.length; i; j = Math.floor(Math.random() * i), x = o[--i], o[i] = o[j], o[j] = x);
    return o;
};
function shuffleArray(array) {
    for (var i = array.length - 1; i > 0; i--) {
        var j = Math.floor(Math.random() * (i + 1));
        var temp = array[i];
        array[i] = array[j];
        array[j] = temp;
    }
    return array;
}

var eatCount = 0;
var fallobjectCount = 3;
//get random  value



function mouseDownListener(evt) {

     
    var evt1 = evt.changedTouches[0];

    var i;
 
    var bRect = $("#gameCanvas")[0].getBoundingClientRect();
     
    mouseX = (evt1.clientX - bRect.left) * ($("#gameCanvas")[0].width / bRect.width);
    mouseY = (evt1.clientY - bRect.top) * ($("#gameCanvas")[0].height / bRect.height);

   
        if (HitLeft(mouseX, mouseY)) {
            catX = catX - 10;
            //  catY = catY - 10;

            if (!flip) {
                flip = true;
            }
        }
        if (HitRight(mouseX, mouseY)) {
            catX = catX + 10;
            // catY = catY - 10;
            if (flip) {
                flip = false;
            }
        }

        if (HitJump(mouseX, mouseY)) {
            // catY = catY - 10;
            if (flip) {
                catX = catX - 10;

            }
            else {
                catX = catX + 10;
            }
            catY = catY - 50;
            isjump = true;
        }
    

        if (HitNextPlayButton(mouseX, mouseY))
        {
            if(isGameLost)
            {
                window.location.reload();
            }
            else if(isGameOver)
            {
                window.location.href = 'level8.html';
            }
        }


    // window.addEventListener(endEvent, mouseUpListener, false);

    //code below prevents the mouse down from having an effect on the main browser window:
    if (evt.preventDefault) {
        evt.preventDefault();
    } //standard
    else if (evt.returnValue) {
        evt.returnValue = false;
    } //older IE
    return false;
}

function HitLeft(mx, my) {
    
    
    var flag = false;
    var xyz = canvasWidth / 4;
    
    var left = xyz, right = xyz+40;
    var top = canvasheight - 40, bottom = canvasheight;
    
    if (right >= mx
        && left <= mx
        && bottom >= my
        && top <= my) {
        flag = true;
    }


    return flag;

}
function HitJump(mx, my) {

    var flag = false;

    var flag = false;
    var xyz = canvasWidth / 4+40;

    var left = xyz, right = xyz + 40;
    var top = canvasheight - 40, bottom = canvasheight;

    if (right >= mx
        && left <= mx
        && bottom >= my
        && top <= my) {
        flag = true;
    }


    return flag;

}
function HitRight(mx, my) {

    var flag = false;

    var flag = false;
    var xyz = canvasWidth / 4+85;

    var left = xyz, right = xyz + 40;
    var top = canvasheight - 40, bottom = canvasheight;

    if (right >= mx
        && left <= mx
        && bottom >= my
        && top <= my) {
        flag = true;
    }


    return flag;

}


function HitNextPlayButton(mx, my) {

    var flag = false;

    var flag = false;
    var xyz = canvasWidth/4;

    var left = xyz, right = xyz + 40;
    var top = (canvasheight/2)+25, bottom = (canvasheight/2)+25+40;

    if (right >= mx
        && left <= mx
        && bottom >= my
        && top <= my) {
        flag = true;
    }


    return flag;

}


function Message(message) {
    var ctx = $("#gameCanvas")[0].getContext('2d');
    ctx.beginPath();



    ctx.fillStyle = "black"
    ctx.font = "12px Georgia";
    //  ctx.fillText(message, pointXY[56].X, pointXY[56].Y + 70);
    ctx.fillText("Score: "+message,canvasWidth-100, canvasheight - 20);
    ctx.closePath();




}

function MessageGameOver(type)
{
    var ctx = $("#gameCanvas")[0].getContext('2d');
    ctx.beginPath();






    ctx.fillStyle = "black"
    ctx.font = "12px Georgia";
    //  ctx.fillText(message, pointXY[56].X, pointXY[56].Y + 70);
   


    if (type == 1) {
        
        ctx.fillText("You lost the game, Play it again.", canvasheight/6, canvasheight / 2);
        ctx.fillText("score 1000 for next level.", canvasheight/6, (canvasheight / 2) + 15);
        
        ctx.drawImage(imgPlay, canvasWidth / 4, (canvasheight / 2) + 25, 40, 40);
    }
    else if (type == 2) {
      
        ctx.fillText("You win  this level, Play next level.", canvasWidth / 6, (canvasheight / 2)+15);
        ctx.drawImage(imgNext, canvasWidth / 4, (canvasheight / 2) + 25, 40, 40);
    }
    
    ctx.closePath();
}
