var pageid = -1;;

var app = angular.module("MyDietchartApp", ["ngRoute"]);
app.config(function ($routeProvider) {
    $routeProvider
        .when("/", {
            templateUrl: "master.html",
            controller: "MasterController"
        })
    .when("/home", {
        templateUrl: "home.html",
        controller: "HomeController"
    })
    .when("/CreateChart", {
        templateUrl: "CreateChart.html",
        controller: "CreateChartController"
    })
     .when("/ChartResult", {
         templateUrl: "ChartResult.html",
         controller: "ChartResultController"
     })
    .when("/setting", {
        templateUrl: "setting.html",
        controller: "settingController"
    })
        .when("/order", {
            templateUrl: "order.html",
            controller: "orderController"
        })
        .when("/history", {
            templateUrl: "history.html",
            //controller: "historyController"
        })
        .when("/Result", {
            templateUrl: "Result.html",
            controller: "ResultController"
        })
        .when("/Rules", {
            templateUrl: "Rules.html",
            controller: "RulesController"
        })
    .when("/contact", {
        templateUrl: "contact.html",
        controller: "contactController"
    });


});


app.controller('MasterController', function ($scope) {

    $scope.DisplayAppCategory = true;
    $scope.DisplayApplist = false;
    $scope.BackHome = false;
    $scope.Title = "Apps Category";

    //  alert(localStorage.getItem("AppCategoryList"));
    //  $scope.visibility = '0';
    $scope.AppCategoryList = JSON.parse(localStorage.getItem("AppCategoryList"));
    $scope.ShowAppList = function (obj) {
        $scope.DisplayAppCategory = false;
        $scope.DisplayApplist = true;
        $scope.BackHome = true;
        //alert(obj.id)

        $scope.Title = obj.name;
        $scope.categoryid = obj.id;




        $scope.AppsListV2 = JSON.parse(localStorage.getItem('AppsList'));

        angular.forEach($scope.AppsListV2, function (i, j) {

            if ((i.isdevice == "0")&&(i.catid==obj.id)) {

               // alert('abc_'+i.appid);
                navigator.startApp.check(i.appid, function (message) { /* success */
                    //console.log(message); // => OK
                 //   alert(message+'_'+i.appid);
                    i.isdevice = '1';
                   
                    localStorage.setItem('AppsList', JSON.stringify($scope.AppsListV2));
                    document.getElementById("em_" + i.appid).style.visibility = 'hidden'
                },
                function (error) { /* error */

                }
             );
            }



        });

        $scope.AppsList = $scope.AppsListV2


        //alert(JSON.stringify($scope.applist));




        
        //  alert(localStorage.getItem('AppsList'));



        // WindowResize();

    };
    $scope.BackHomePage = function () {
        $scope.DisplayAppCategory = true;
        $scope.DisplayApplist = false;
        $scope.BackHome = false;
        $scope.Title = "Apps Category";
    }

    $scope.OpenApp = function (appsId) {

        navigator.startApp.check(appsId, function (message) { /* success */

            navigator.startApp.start(appsId, function (message) { /* success */

            },
                function (error) { /* error */
                    alert(error);
                });

            //console.log(message); // => OK
        },
        function (error) { /* error */
            //    alert(appsId);
            // show the interstitial when you want it
            // if (AdMob) {
            //     AdMob.showInterstitial();
            // }
            var ref = window.open("market://details?id=" + appsId, '_system');
            // ref.show();
            // setTimeout(window.open("market://details?id=" + appsId, '_system'), 1000 * 2);
            // window.location.replace("market://details?id=" + appsId);
            // window.open("https://play.google.com/store/apps/details?id=" + appsId, '_system');
            // window.location.href = "https://play.google.com/store/apps/details?id=" + appsId;


        }
        );

    }

    // WindowResize();
});

app.controller('SettingController', function ($scope) {
    // alert('s');
    //$(".loader_back").show();

    $scope.AppCategoryList = JSON.parse(localStorage.getItem("AppCategoryList"));

    $scope.DeviceAppsList = JSON.parse(localStorage.getItem('deviceAppsList'));
     // alert(JSON.stringify($scope.DeviceAppsList));
    $scope.AppsList = JSON.parse(localStorage.getItem('AppsList'));
    // WindowResize();
   // $scope.DeviceAppsList = $scope.AppsList;
  //  alert(JSON.stringify($scope.DeviceAppsList));
    $scope.SetCategory = function (app, cat) {
        var i = 0;
        var flag = true;

        app.catid = cat;

        angular.forEach($scope.AppsList, function (i, j) {


            if (i.appid == app.appid) {
                //    alert(cat);
                i.catid = cat;
                //    alert(i.catid);
                flag = false;
                localStorage.setItem('AppsList', JSON.stringify($scope.AppsList));
              
                //   alert(app.appid);
            }

        });


        if (flag) {
            var item = { name: app.name, id: $scope.AppsList.length, catid: cat, appid: app.appid, imagename: app.imagename, isdevice:'1' };
            //  alert(item);
            $scope.AppsList.push(item);
            localStorage.setItem('AppsList', JSON.stringify($scope.AppsList));
        }

        localStorage.setItem('deviceAppsList', JSON.stringify($scope.DeviceAppsList));





    }
});


app.controller('CategoryController', function ($scope) {

    $scope.AppCategoryList = JSON.parse(localStorage.getItem("AppCategoryList"));

    $scope.SetOnOffCategory = function (event) {

        var chk = document.getElementById(event.target.id);

        //  alert(event.target.id);
        angular.forEach($scope.AppCategoryList, function (i, j) {

            if (i.id == event.target.id) {

                if (chk.checked) {
                    i.visible = '1';

                }
                else {
                    i.visible = '0';
                }
                //  alert(JSON.stringify($scope.AppCategoryList));

                //   alert(app.appid);
            }

        });
        localStorage.setItem('AppCategoryList', JSON.stringify($scope.AppCategoryList));
        //alert(JSON.stringify($scope.AppCategoryList));
        //;
        //  alert(event.target.id);
        // alert(chk.checked);
    };

    WindowResize();
});


function vibrate(message) {
    //alert('hi');
    //navigator.notification.beep(2);
    window.plugin.notification.local.add({
        message: message
    });



}
var enabledAdMob = true; // easily enable/disable AdMob
var admobid = {};
admobid = { // for Android
    banner: 'ca-app-pub-6978036712957508/9026299875', // or DFP format "/6253334/dfp_example_ad"
    interstitial: 'ca-app-pub-6978036712957508/6079506674'
};
function onDeviceReady() {
    document.addEventListener("backbutton", onBackKeyDown, false);
    /*  document.addEventListener("backbutton", function (e) {
         e.preventDefault();
     }, false);
    */
    // if (localStorage.getItem("deviceAppsList") == null) 
    if (pageid == "1") {
        var success = function (app_list) {
            //alert("a");
            var obj = [];
            obj = app_list;

            if((localStorage.getItem("DeviceAppLength") == null) || localStorage.getItem("DeviceAppLength") != obj.length)
            {
             //   alert("b");
            var deviceAppsList = [];
            //  var AppsListV3 = [];
            var applist = JSON.parse(localStorage.getItem("AppsList"));
            var ln = applist.length;
            for (var i = 0; i < obj.length; i++) {
                var appids = obj[i].img.split('/');
                if (appids.length > 0) {
                    var appimagename = appids[appids.length - 1];
                    var appid = appimagename.substring(0, appimagename.length - 4);
                //    alert(appid);
                    if (appid != "com.Appslist.important") {

                        var flag = true;




                        angular.forEach(applist, function (l, k) {

                            if (l.appid == appid) {
                                var item = { name: obj[i].name, id: l.id, catid: l.catid, appid: appid, imagename: obj[i].img, isdevice: '1' };
                                deviceAppsList.push(item);
                                //  alert(item.name + "_" + item.isdevice);
                                //   AppsListV3.push(item);
                                flag = false;
                                l.isdevice = "1";

                                
                            }
                            
                        });



                        if (flag) {
                            var item = { name: obj[i].name, id: (i + 1), catid: '12', appid: appid, imagename: obj[i].img, isdevice: '1' };
                            deviceAppsList.push(item);
                            applist.push(item);
                            // AppsListV3.push(item);//added in new version


                        }
                    }

                    // alert(JSON.stringify((item)));


                }
            }


         
            

            localStorage.setItem("AppsList", JSON.stringify(applist));
            localStorage.setItem("deviceAppsList", JSON.stringify(deviceAppsList));


            //  alert(JSON.stringify(deviceAppsList));

            localStorage.setItem("DeviceAppLength", obj.length);
        }
            window.location.href = 'master.html'
        };
        var error = function (app_list) { alert("Oopsie! " + app_list); };
        Applist.createEvent('', '', '', new Date(), new Date(), success, error)

    }

    if (enabledAdMob) {
        AdMob.createBanner({
            adId: admobid.banner,
            adSize: 'SMART_BANNER',
            position: AdMob.AD_POSITION.BOTTOM_RIGHT,
            autoShow: true,
            isTesting: false
        });


        // prepare and load your ad resource in background to minimize the wait time and increase conversion
        //  if (AdMob) {
        //     AdMob.prepareInterstitial({ adId: admobid.interstitial, autoShow: false, isTesting: true });
        //}



    }




}
function onBackKeyDown(e) {
    e.preventDefault();
    navigator.notification.confirm("Are you sure you want to exit ?", onConfirm, "Confirmation", "Yes,No");
    // Prompt the user with the choice
}

function onConfirm(button) {
    if (button == 2) {//If User selected No, then we just do nothing
        return;
    } else {
        navigator.app.exitApp();// Otherwise we quit the app.
    }
}